unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Data.DB, ekbasereport,
  ekrtf, ekfunc;

type
  TForm1 = class(TForm)
    EkRTF1: TEkRTF;
    EkUDFList1: TEkUDFList;
    Button2: TButton;
    RTFDialog: TOpenDialog;
    Button3: TButton;
    Label1: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure EkUDFList1Functions0Calculate(Sender: TObject; Args: TEkUDFArgs;
      ArgCount: Integer; UDFResult: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
begin
  (* check report template file *)
  if not FileExists(EkRTF1.InFile) then
  begin
    if RTFDialog.Execute then begin
       EkRTF1.InFile := RTFDialog.FileName;
    end else exit;
  end;

  (* create report *)
  EkRtf1.ClearVars;
  EkRtf1.CreateVar('Variable1','This is report variable');
  EkRtf1.OutFile := 'EK_RTF_UDF'+IntToStr(Random(10000))+'.doc';
  EkRtf1.ExecuteOpen([],SW_SHOW);

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   Form1.Close;
end;

procedure TForm1.EkUDFList1Functions0Calculate(Sender: TObject;
  Args: TEkUDFArgs; ArgCount: Integer; UDFResult: TObject);
var
  s:string;
begin
(* ArgCount is number of parameters passed to the function *)
(* Args[] is an array of parameters *)
(* UDFResult - is an object for the function result *)

s := '';

if (ArgCount = 0) then begin
   TEkReportVariable(UDFResult).AsString := 'The function was called without parameters';
   exit;
end;

(* If parameter is a constant or variable *)
if Args[0] is TEkReportVariable then begin
   s := TEkReportVariable(Args[0]).AsString;
end;

(* If parameter is a database field *)
if Args[0] is TField then begin
   s := TField(Args[0]).AsString;
end;

(* Result *)
TEkReportVariable(UDFResult).AsString := 'The function was called with value: ' + s;

end;

end.
